=== debian/changelog ===
retroarch (1.7.3+dfsg1-1~mx17+1) mx; urgency=medium

  * Repackaged from buster for MX-17/18.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 02 Mar 2019 08:10:33 -0800
